﻿Imports System
Imports System.IO
Imports System.Windows.Forms
Imports Microsoft.VisualBasic
Imports System.Drawing
Imports System.Drawing.Printing

Namespace WinTr
Public Class MainClass
    Public ObjectNameOfActiveScreen As System.Collections.ArrayList
    Public ObjectOfActiveScreen As System.Collections.ArrayList
	Dim DataGridView_1 as DataGridView
    Dim mRow As Integer = 0
    Dim newpage As Boolean = True
	Dim PrintPreviewDialog1 as new PrintPreviewDialog
	Public Sub Load
		Dim Index as integer = ObjectNameOfActiveScreen.IndexOf("DataGridView_1")
		if Index = -1 Then
			MsgBox("DataGridView_1 cannot found!")
			Exit Sub
		End If
		DataGridView_1 = ObjectOfActiveScreen(Index)
        Dim PrintDocument1 As New PrintDocument
        AddHandler PrintDocument1.PrintPage, AddressOf PrintDocument1_PrintPage
        AddHandler PrintDocument1.BeginPrint, AddressOf PrintDocument1_BeginPrint
        'Without dialog----------------------------------------------------------
        PrintDocument1.Print()
        'With dialog-------------------------------------------------------------        
        'PrintPreviewDialog1.Document = PrintDocument1
        'PrintPreviewDialog1.ShowDialog()
	End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        ' sets it to show '...' for long text
        Dim fmt As StringFormat = New StringFormat(StringFormatFlags.LineLimit)
        fmt.LineAlignment = StringAlignment.Center
        fmt.Trimming = StringTrimming.EllipsisCharacter
        Dim y As Int32 = e.MarginBounds.Top
        Dim rc As Rectangle
        Dim x As Int32
        Dim h As Int32 = 0
        Dim row As DataGridViewRow
        ' print the header text for a new page
        '   use a grey bg just like the control
        If newpage Then
            row = DataGridView_1.Rows(mRow)
            x = e.MarginBounds.Left
            For Each cell As DataGridViewCell In row.Cells
                ' since we are printing the control's view,
                ' skip invidible columns
                If cell.Visible Then
                    rc = New Rectangle(x, y, cell.Size.Width, cell.Size.Height)
                    e.Graphics.FillRectangle(Brushes.LightGray, rc)
                    e.Graphics.DrawRectangle(Pens.Black, rc)
                    ' reused in the data pront - should be a function
                    Select Case DataGridView_1.Columns(cell.ColumnIndex).DefaultCellStyle.Alignment
                        Case DataGridViewContentAlignment.BottomRight, DataGridViewContentAlignment.MiddleCenter
                            fmt.Alignment = StringAlignment.Far
                            rc.Offset(-1, 0)
                        Case DataGridViewContentAlignment.BottomCenter, DataGridViewContentAlignment.MiddleCenter
                            fmt.Alignment = StringAlignment.Center
                        Case Else
                            fmt.Alignment = StringAlignment.Near
                            rc.Offset(2, 0)
                    End Select
                    e.Graphics.DrawString(DataGridView_1.Columns(cell.ColumnIndex).HeaderText, DataGridView_1.Font, Brushes.Black, rc, fmt)
                    x += rc.Width
                    h = Math.Max(h, rc.Height)
                End If
            Next
            y += h
        End If
        newpage = False
        ' now print the data for each row
        Dim thisNDX As Int32
        For thisNDX = mRow To DataGridView_1.RowCount - 1
            ' no need to try to print the new row
            If DataGridView_1.Rows(thisNDX).IsNewRow Then Exit For
            row = DataGridView_1.Rows(thisNDX)
            x = e.MarginBounds.Left
            h = 0
            ' reset X for data
            x = e.MarginBounds.Left
            ' print the data
            For Each cell As DataGridViewCell In row.Cells
                If cell.Visible Then
                    rc = New Rectangle(x, y, cell.Size.Width, cell.Size.Height)
                    ' SAMPLE CODE: How To 
                    ' up a RowPrePaint rule
                    'If Convert.ToDecimal(row.Cells(5).Value) < 9.99 Then
                    '    Using br As New SolidBrush(Color.MistyRose)
                    '        e.Graphics.FillRectangle(br, rc)
                    '    End Using
                    'End If
                    e.Graphics.DrawRectangle(Pens.Black, rc)
                    Select Case DataGridView_1.Columns(cell.ColumnIndex).DefaultCellStyle.Alignment
                        Case DataGridViewContentAlignment.BottomRight, DataGridViewContentAlignment.MiddleRight
                            fmt.Alignment = StringAlignment.Far
                            rc.Offset(-1, 0)
                        Case DataGridViewContentAlignment.BottomCenter, DataGridViewContentAlignment.MiddleCenter
                            fmt.Alignment = StringAlignment.Center
                        Case Else
                            fmt.Alignment = StringAlignment.Near
                            rc.Offset(2, 0)
                    End Select
                    e.Graphics.DrawString(cell.FormattedValue.ToString(), DataGridView_1.Font, Brushes.Black, rc, fmt)
                    x += rc.Width
                    h = Math.Max(h, rc.Height)
                End If
            Next
            y += h
            ' next row to print
            mRow = thisNDX + 1
            If y + h > e.MarginBounds.Bottom Then
                e.HasMorePages = True
                ' mRow -= 1   causes last row to rePrint on next page
                newpage = True
                Return
            End If
        Next
    End Sub

    Private Sub PrintDocument1_BeginPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs)
        mRow = 0
        newpage = True
        PrintPreviewDialog1.PrintPreviewControl.StartPage = 0
        PrintPreviewDialog1.PrintPreviewControl.Zoom = 1.0
    End Sub

End Class
End Namespace






